
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Bonus_programsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const bonus_programs = await db.bonus_programs.create(
            {
                id: data.id || undefined,
        
        program_name: data.program_name
        ||
        null
            ,
            
        program_status: data.program_status
        ||
        null
            ,
            
        target_metric: data.target_metric
        ||
        null
            ,
            
        target_value: data.target_value
        ||
        null
            ,
            
        reward_type: data.reward_type
        ||
        null
            ,
            
        reward_rate: data.reward_rate
        ||
        null
            ,
            
        reward_amount: data.reward_amount
        ||
        null
            ,
            
        gift_description: data.gift_description
        ||
        null
            ,
            
        starts_at: data.starts_at
        ||
        null
            ,
            
        ends_at: data.ends_at
        ||
        null
            ,
            
        terms: data.terms
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await bonus_programs.setTenant( data.tenant || null, {
            transaction,
        });
        
        await bonus_programs.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return bonus_programs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const bonus_programsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                program_name: item.program_name
            ||
            null
            ,
            
                program_status: item.program_status
            ||
            null
            ,
            
                target_metric: item.target_metric
            ||
            null
            ,
            
                target_value: item.target_value
            ||
            null
            ,
            
                reward_type: item.reward_type
            ||
            null
            ,
            
                reward_rate: item.reward_rate
            ||
            null
            ,
            
                reward_amount: item.reward_amount
            ||
            null
            ,
            
                gift_description: item.gift_description
            ||
            null
            ,
            
                starts_at: item.starts_at
            ||
            null
            ,
            
                ends_at: item.ends_at
            ||
            null
            ,
            
                terms: item.terms
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const bonus_programs = await db.bonus_programs.bulkCreate(bonus_programsData, { transaction });

        // For each item created, replace relation files
        

        return bonus_programs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const bonus_programs = await db.bonus_programs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.program_name !== undefined) updatePayload.program_name = data.program_name;
        
        
        if (data.program_status !== undefined) updatePayload.program_status = data.program_status;
        
        
        if (data.target_metric !== undefined) updatePayload.target_metric = data.target_metric;
        
        
        if (data.target_value !== undefined) updatePayload.target_value = data.target_value;
        
        
        if (data.reward_type !== undefined) updatePayload.reward_type = data.reward_type;
        
        
        if (data.reward_rate !== undefined) updatePayload.reward_rate = data.reward_rate;
        
        
        if (data.reward_amount !== undefined) updatePayload.reward_amount = data.reward_amount;
        
        
        if (data.gift_description !== undefined) updatePayload.gift_description = data.gift_description;
        
        
        if (data.starts_at !== undefined) updatePayload.starts_at = data.starts_at;
        
        
        if (data.ends_at !== undefined) updatePayload.ends_at = data.ends_at;
        
        
        if (data.terms !== undefined) updatePayload.terms = data.terms;
        
        
        updatePayload.updatedById = currentUser.id;

        await bonus_programs.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await bonus_programs.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await bonus_programs.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return bonus_programs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const bonus_programs = await db.bonus_programs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of bonus_programs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of bonus_programs) {
                await record.destroy({transaction});
            }
        });


        return bonus_programs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const bonus_programs = await db.bonus_programs.findByPk(id, options);

        await bonus_programs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await bonus_programs.destroy({
            transaction
        });

        return bonus_programs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const bonus_programs = await db.bonus_programs.findOne(
            { where },
            { transaction },
        );

        if (!bonus_programs) {
            return bonus_programs;
        }

        const output = bonus_programs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await bonus_programs.getTenant({
            transaction
        });
        
        
        output.organizations = await bonus_programs.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.program_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'bonus_programs',
                        'program_name',
                        filter.program_name,
                    ),
                };
            }
            
            if (filter.gift_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'bonus_programs',
                        'gift_description',
                        filter.gift_description,
                    ),
                };
            }
            
            if (filter.terms) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'bonus_programs',
                        'terms',
                        filter.terms,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            starts_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    ends_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.target_valueRange) {
                const [start, end] = filter.target_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    target_value: {
                    ...where.target_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    target_value: {
                    ...where.target_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reward_rateRange) {
                const [start, end] = filter.reward_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reward_rate: {
                    ...where.reward_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reward_rate: {
                    ...where.reward_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reward_amountRange) {
                const [start, end] = filter.reward_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reward_amount: {
                    ...where.reward_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reward_amount: {
                    ...where.reward_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.starts_atRange) {
                const [start, end] = filter.starts_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    starts_at: {
                    ...where.starts_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    starts_at: {
                    ...where.starts_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ends_atRange) {
                const [start, end] = filter.ends_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.program_status) {
                where = {
                    ...where,
                program_status: filter.program_status,
            };
            }
            
            if (filter.target_metric) {
                where = {
                    ...where,
                target_metric: filter.target_metric,
            };
            }
            
            if (filter.reward_type) {
                where = {
                    ...where,
                reward_type: filter.reward_type,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.bonus_programs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'bonus_programs',
                        'program_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.bonus_programs.findAll({
            attributes: [ 'id', 'program_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['program_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.program_name,
        }));
    }

    
};

